package com.yice.webadmin.app.controller;

import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.github.pagehelper.page.PageMethod;
import com.yice.webadmin.app.vo.*;
import com.yice.webadmin.app.dto.*;
import com.yice.webadmin.app.model.*;
import com.yice.webadmin.app.service.*;
import com.yice.common.core.object.*;
import com.yice.common.core.util.*;
import com.yice.common.core.constant.*;
import com.yice.common.core.annotation.MyRequestBody;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * 模型版本操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "模型版本管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/modelVersion")
public class ModelVersionController {

    @Autowired
    private ModelVersionService modelVersionService;

    /**
     * 新增模型版本数据。
     *
     * @param modelVersionDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"modelVersionDto.versionId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody ModelVersionDto modelVersionDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(modelVersionDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        ModelVersion modelVersion = MyModelUtil.copyTo(modelVersionDto, ModelVersion.class);
        modelVersion = modelVersionService.saveNew(modelVersion);
        return ResponseResult.success(modelVersion.getVersionId());
    }

    /**
     * 更新模型版本数据。
     *
     * @param modelVersionDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody ModelVersionDto modelVersionDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(modelVersionDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        ModelVersion modelVersion = MyModelUtil.copyTo(modelVersionDto, ModelVersion.class);
        ModelVersion originalModelVersion = modelVersionService.getById(modelVersion.getVersionId());
        if (originalModelVersion == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!modelVersionService.update(modelVersion, originalModelVersion)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除模型版本数据。
     *
     * @param versionId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long versionId) {
        if (MyCommonUtil.existBlankArgument(versionId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(versionId);
    }

    /**
     * 列出符合过滤条件的模型版本列表。
     *
     * @param modelVersionDtoFilter 过滤对象。
     * @param orderParam 排序参数。
     * @param pageParam 分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<ModelVersionVo>> list(
            @MyRequestBody ModelVersionDto modelVersionDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        ModelVersion modelVersionFilter = MyModelUtil.copyTo(modelVersionDtoFilter, ModelVersion.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, ModelVersion.class);
        List<ModelVersion> modelVersionList =
                modelVersionService.getModelVersionListWithRelation(modelVersionFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(modelVersionList, ModelVersion.INSTANCE));
    }

    /**
     * 查看指定模型版本对象详情。
     *
     * @param versionId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<ModelVersionVo> view(@RequestParam Long versionId) {
        ModelVersion modelVersion = modelVersionService.getByIdWithRelation(versionId, MyRelationParam.full());
        if (modelVersion == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        ModelVersionVo modelVersionVo = ModelVersion.INSTANCE.fromModel(modelVersion);
        return ResponseResult.success(modelVersionVo);
    }

    private ResponseResult<Void> doDelete(Long versionId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        ModelVersion originalModelVersion = modelVersionService.getById(versionId);
        if (originalModelVersion == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!modelVersionService.remove(versionId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
